﻿using ModbusTester.Model;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace ModbusTester
{
    /// <summary>
    /// MainWindow.xaml에 대한 상호 작용 논리
    /// </summary>
    public partial class MainWindow : Window
    {
        private ModbusModel _pmsModbus;
        private DataModel _pmsData;
        public MainWindow()
        {
            InitializeComponent();
            InitInstance();
        }

        private void InitInstance()
        {
            _pmsModbus = new ModbusModel();
            _pmsModbus.OnConnectionChanged += _pmsModbus_OnConnectionChanged;
            _pmsModbus.OnSendDataChanged += _pmsModbus_OnSendDataChanged;
            _pmsModbus.OnReceiveDataChanged += _pmsModbus_OnReceiveDataChanged;
            _pmsModbus.OnDataRead += _pmsModbus_OnDataRead;
            _pmsModbus.Port = 502;

            _pmsData = DataContext as DataModel;
        }

        private void _pmsModbus_OnDataRead(object sender, DataModel e)
        {
            Application.Current.Dispatcher.Invoke(() =>
            {
                DataContext = e;
                _pmsData = DataContext as DataModel;
            });
        }

        private string GetDataString(float[] data)
        {
            string result = "";
            foreach (float item in data)
            {
                result += $"{item.ToString("N2")}, ";
            }

            return result;
        }

        private void _pmsModbus_OnReceiveDataChanged(object sender, byte[] e)
        {

        }

        private void _pmsModbus_OnSendDataChanged(object sender, byte[] e)
        {

        }

        private void _pmsModbus_OnConnectionChanged(object sender, bool e)
        {
            Application.Current.Dispatcher.Invoke(() =>
            {
                if (_pmsModbus.IsConnected == true)
                {
                    lblStatus.Background = (SolidColorBrush)Application.Current.FindResource("traffic_green");
                    tbtConnect.IsChecked = true;
                }
                else
                {
                    lblStatus.Background = (SolidColorBrush)Application.Current.FindResource("traffic_red");
                    tbtConnect.IsChecked= false;
                }
            });
        }

        private void SetModbus()
        {
            _pmsModbus.IP = _pmsData.IP;
            _pmsModbus.Interval = _pmsData.Interval;
        }

        private void tbtConnect_Checked(object sender, RoutedEventArgs e)
        {

            try
            {
                SetModbus();
                _pmsModbus.Connect();

            }
            catch (Exception ex)
            {
                tbtConnect.IsChecked = false;
                MessageBox.Show($"Error: {ex.Message}");
            }
        }

        private void tbtConnect_Unchecked(object sender, RoutedEventArgs e)
        {
            try
            {
                _pmsModbus.Disconnect();
            }
            catch (Exception ex)
            {
                tbtConnect.IsChecked = true;
                MessageBox.Show($"Error: {ex.Message}");
            }
        }
    }
}
