﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ModbusTester.Model
{
    public class DataModel : INotifyPropertyChanged
    {
        public event PropertyChangedEventHandler PropertyChanged;

        public string IP { get; set; }
        public int Interval { get; set; }

        public float ConfigFlowrate { get; set; }
        public float ActualFlowrate { get; set; }
        public int NumberOfChannel { get; set; }

        private ObservableCollection<PMSChannelData> _data;
        public ObservableCollection<PMSChannelData> Data
        {
            get { return _data; }
            set
            {
                _data = value;
                OnPropertyChanged(nameof(Data));
            }
        }

        public DataModel()
        {
            IP = "200.200.200.200";
            Interval = 60;

            _data = new ObservableCollection<PMSChannelData>();
        }

        private void OnPropertyChanged(string propertyName = null)
        {
            PropertyChanged?.Invoke(this, new PropertyChangedEventArgs(propertyName));
        }
    }

    public class PMSChannelData
    {
        public string Name { get; set; }
        public DateTime TimeStamp { get; set; }
        public int CummulativeRaw { get; set; }
    }
}
